# GL1100
####################################################################################################################
# Script creates entries in the Extender log table when a user opens and closes the GL1100 / GL Account screen
# uses the default Extender LOG table, View ID is the Roto id of the screen, Key field is Open or Close 
####################################################################################################################
# Copyright @Orchid Systems 2021
####################################################################################################################

from accpac import *
import time
import datetime
from datetime import datetime

def main(args):
	MyUI()

class MyUI(UI):
	def __init__(self):
		UI.__init__(self)
		#showMessageBox("open by " + user)
		self.writeToAudit("GL1100", "Open")
		
		# when closing with the x top right
		self.onClose = self.logBeforeClosing
		# when using the close button bottom right
		self.onEvent("OnUIAppClosed", self.onClosing)
		self.show()

	def onClosing(self,e):
		self.writeToAudit("GL1100", "Close")
			
	def logBeforeClosing(self):
		self.writeToAudit("GL1100", "Close")
			
	def writeToAudit(self, sProgId, sAction):
		dt = datetime.now()

		# open view.
		VILOG = openView("VI0002", 1)
		VILOG.recordClear()
		
		# populate key fields:
		f_datetime = dt.strftime("%Y%m%d%H%M%S%f")[:-2]
		#f_viewid = rotoID
		f_viewid = sProgId
		f_change = 0
		f_key = "GL1100"
		
		# check if record exists in VILOG.
		VILOG.put("DATETIME", f_datetime)
		VILOG.put("VIEWID", f_viewid)
		VILOG.put("CHANGE", f_change)
		VILOG.put("KEY", f_key)
		res = VILOG.read()
		while (res == 0):
			# VI audit log record was found. Increment change variable and try again.
			f_change = int(VILOG.get("CHANGE")) + 1

			if f_change > 100:
				showMessageBox("don't write")
				return Continue		# Don't write to the audit. Something's gone wrong and we've reached a hundred count. This shouldn't happen so exit and don't write to the VILOG table.

			else:
				showMessageBox("read again")
				VILOG.recordClear()
				VILOG.put("DATETIME", f_datetime)
				VILOG.put("VIEWID", f_viewid)
				VILOG.put("CHANGE", f_change) # has been incremented by 1.
				VILOG.put("KEY", f_key)
				res = VILOG.read()

		
		# populate other fields:
		f_date = dt.strftime("%Y%m%d")
		f_time = dt.strftime("%H%M%S00")
		f_field = sAction
		f_userid = user


		VILOG.recordClear()
		VILOG.put("DATETIME", f_datetime)
		VILOG.put("VIEWID", f_viewid)
		VILOG.put("CHANGE", f_change)
		VILOG.put("KEY", f_key)
		VILOG.put("DATE", f_date)
		VILOG.put("TIME", f_time)
		VILOG.put("USERID", f_userid)
		VILOG.put("FIELD", f_field)
		#VILOG.put("FROM", sAction)
		#VILOG.put("TO", sAction)

		VILOG.insert()

